/**************************************************************************************************

Copyright (c) 2007-2012   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  <gl/gl.h>
#include  "mtk_save_image.h"
#include  "../common/graphics/gl_image.h"
#include  "../common/win_dlg.h"
#include  "mtk_draw_struct.h"
#include  "mtk_pbuffer.h"


//  externs
mtk_draw_struct		calc_draw_struct(int w, int h);
void				draw_scene_all(const mtk_draw_struct& ds, bool bClear);

//
static char szFileName[MAX_PATH] = "\0";
static int ImageType;
static int SaveImageWidth, SaveImageHeight;



const char*
get_save_image_high_res_filename()
{
	return  szFileName;
}

bool
save_image_high_resolution_get_filename(int w, int h)
{

	const bilingual szFilter = {
		"JPEG (*.jpg)\0*.jpg\0PNG (*.png)\0*.png\0Bitmap File (*.bmp)\0*.bmp\0",
		"JPEG (*.jpg)\0*.jpg\0PNG (*.png)\0*.png\0rbg}bv t@C (*.bmp)\0*.bmp\0",
	};
	const bilingual szDlgTitle = {
		"Save Image As...",
		"摜t@Cɕۑ"
	};

	if (get_language()==LANG_ENG) {
		ImageType = GetFileName(NULL, szFileName, szFilter.text_E, szDlgTitle.text_E, true);
	} else {
		ImageType = GetFileName(NULL, szFileName, szFilter.text_J, szDlgTitle.text_J, true);
	}
	if (ImageType <= 0)  {
		szFileName[0] = '\0';
		return false;
	}

	SaveImageWidth = w;
	SaveImageHeight = h;

	return  true;
}

bool
save_image_high_resolution()
{
	if (szFileName[0] == '\0')  return false;

	int w = SaveImageWidth;
	int h = SaveImageHeight;
	int wmax = get_pbuffer_width_max();
	int hmax = get_pbuffer_height_max();
	if (w > wmax)  w = wmax;
	if (h > hmax)  h = hmax;


	if ( !create_pbuffer(w, h) )  return false;
	glViewport(0,0,w,h);
	draw_scene_all(calc_draw_struct(w, h), true);
	image  img(0,0,3);
	gl_read_pixels(img, 0,0, w, h);
	destroy_pbuffer();


	switch (ImageType) {
		case 1:	img.saveJPEG(szFileName);	break;
		case 2:	img.savePNG(szFileName);	break;
		case 3:	img.saveBMP(szFileName);	break;
		default:							break;
	}

	return  true;
}