/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_SWITCHES_H__
#define __MTK_SWITCHES_H__

//-------
//  ݒ
//-------
extern int TexShrinkRate;

//---------
//  [h
//---------
enum {
	LANDING_MODE_HORIZONTAL,
	LANDING_MODE_SURFACE_VIEW
};
char	get_landing_mode();
void	set_landing_mode(char mode);

//--------------
//  \XCb`
//--------------
//--- H̕\
const char ECLIPSE_DISP		= 0x01;		// H̉e̕\
const char ECLIPSE_BORDER	= 0x02;		// {eEe̋E
//--- P
const char STAR_DISP		= 0x01;		// \邩
const char STAR_NAME		= 0x02;		// ̌ŗL
const char STAR_NAME_SELECT	= 0x04;		// ǏŗL݂̂\
const char STAR_BAYER		= 0x08;		// ̃oCG
const char STAR_FRAMSTEED	= 0x10;		// ̃tX`[hԍ
const char STAR_HIP			= 0x20;		// HIPԍ
//--- 
const char CNST_NAME		= 0x01;		// 
const char CNST_LINE		= 0x02;		// 
const char CNST_ILLUST		= 0x04;		// G
const char CNST_BND			= 0x08;		// ̋E
//--- 
const char GLXY_OUR_GALAXY		= 0x01;	// ͌n
const char GLXY_GLOB_CLSTR		= 0x02;	// 󐯒c
const char GLXY_NEARBY_GALAXY	= 0x04;	// ߖT
const char GLXY_DISTANT_GALAXY	= 0x08;	// 
const char GLXY_QSO				= 0x10;	// QSO
//--- XP[
const char SCALE_CIRCLE		= 0x01;		// XP[~
const char SCALE_SQUARE		= 0x02;		// XP[g



//-------------
//  Time Step
//-------------
enum {
	TIMESTEP_10SEC,
	TIMESTEP_MIN,
	TIMESTEP_10MIN,
	TIMESTEP_HOUR,
	TIMESTEP_4HOUR,
	TIMESTEP_DAY,
	TIMESTEP_WEEK,
	TIMESTEP_MONTH,
	TIMESTEP_YEAR,
	TIMESTEP_10YEAR,
	TIMESTEP_100YEAR
};
extern	char  tyTimeStep;



//---------
//  Scale
//---------
enum {
	SCALE_1000KM,
	SCALE_1AU,
	SCALE_10AU,
	SCALE_100AU,
	SCALE_1000AU,
	SCALE_10000AU,
	SCALE_1LY,
	SCALE_10LY,
	SCALE_100LY,
	SCALE_1KLY,
	SCALE_10KLY,
	SCALE_100KLY,
	SCALE_1MLY,
	SCALE_10MLY,
	SCALE_100MLY,
	SCALE_1GLY,
	SCALE_10GLY
};



//-----------------
//  ̃}[N[h
//-----------------
enum {
	STARMARK_NONE,
	STARMARK_DOUBLE,
	STARMARK_EXOPLANETS
};
extern	char tyStarMark;



//----------------
//  V̐EV
//----------------
enum {
	MILKYWAY_NONE,
	MILKYWAY_VISIBLE,
	MILKYWAY_VISIBLE2,
	MILKYWAY_IR
};
extern	char  tyMilkyWay;		// V̐̎



//--------------
//  C̕\@
//--------------
enum {
	ATMOSPHERE_NONE,
	ATMOSPHERE_SINGLE,
	ATMOSPHERE_MULTIPLE
};
extern char AtmosphereMode;



//================
//  \pXCb`
//================
const int DISPSW_NUM = 4;

//--  Index
enum {
	DISPSW_PLANET,			// f
	DISPSW_SATELLITE,		// q
	DISPSW_MINOR_PLANET,	// f
	DISPSW_TNO				// znOV
};

//--  Mask
const char DISPM_DISP			= 0x01;		// \
const char DISPM_NAME			= 0x02;		// O
const char DISPM_ORBIT			= 0x04;		// O
const char DISPM_SELECT			= 0x08;		// I
const char DISPM_AXIS			= 0x10;		// ]
const char DISPM_CLOUD			= 0x20;		// _
const char DISPM_CITY_LIGHTS	= 0x40;		// i

void	init_disp_switches();
void	set_disp_switch(char idx, char val);
char	get_disp_switch(char idx);
bool	test_disp_switch(char idx, char mask);


extern	char  swEclipse;			// H
extern	char  swStar;				// P
extern	char  swConstellation;		// 
extern	char  swGalaxy;				// 
extern	char  swScaleLine;			// XP[

extern  bool  bSpacecraft;			// T@
extern	bool  bSurfacePointer;		// n\̃|C^
extern	bool  bOortCloud;			// I[g̉_
extern	bool  bVirgoCluster;		// Ƃߍ͒c̃}[N	
extern	bool  bNGC;					// NGCV
extern	bool  bCelestialGrid;		// ԌoEԈ܂̐
extern	bool  bEcliptic;			// 
extern	bool  bHorizonCoord;		// nW
extern	bool  bGalacticGrid;		// oE܂̐
extern	bool  bDate;				// \
extern	bool  bSideLight;			// ̏Ɩ
extern	bool  bSubtitles;			// [h
extern	bool  bAppTitle;			// AvP[Ṽ^Cg
extern	bool  bAbout;				// 
extern	bool  bDebug;				// fobO̕\
extern	bool  bViewInfo;			// _
extern	bool  bSingleEye;			// ЖځiEځjpf̂
extern	bool  bPathInfo;			// pX̕\
extern  bool  bKeyHelp;				// L[{[hwv\
extern	bool  bFPS;					// fps ̕\

//------------------------
//  쐬郀[r[̃^Cv
//------------------------
enum {
	MV_AVI,
	MV_TARGA,
	MV_PNG,
	MV_TARGA6,
	MV_PNG6,
	MV_CUBIC
};

extern char make_movie_type;
extern char mv_filename[256];
extern char mv_basefilename[256];

//-------
//  
//-------
extern	bool  bMovieMode;			// [r[JĂ邩
extern	bool  bMoviePlaying;		// [r[̍Đ
extern	bool  bSettingModeDisp;		// ݒ胂[h̕\


#endif
